package net.t2code.alias.Spigot.cmdManagement;

import net.t2code.alias.Spigot.config.config.SelectConfig;
import net.t2code.alias.Spigot.config.languages.SelectMessages;
import net.t2code.alias.Spigot.objects.AliasObject;
import net.t2code.alias.Spigot.objects.SubAliasObject;
import net.t2code.alias.Spigot.system.BCommandSenderReciver;
import net.t2code.alias.Util;
import net.t2code.lib.Spigot.Lib.commands.Cmd;
import net.t2code.lib.Spigot.Lib.eco.Eco;
import net.t2code.lib.Spigot.Lib.messages.send;
import net.t2code.lib.Spigot.Lib.plugins.PluginCheck;
import net.t2code.lib.Spigot.Lib.replace.Replace;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class ExecuteAlias {
    private static final String prefix = Util.getPrefix();

    protected static void aliasPlayer(CommandSender sender, AliasObject aliasObject, String alias) {
        Player player = (Player) sender;

        if (aliasObject.adminEnable) {
            if (player.hasPermission(aliasObject.adminPermission)) {
                if (aliasObject.adminCommandEnable) {
                    aliasAdminCommand(aliasObject, player);
                }
                if (aliasObject.adminMessageEnable) {
                    aliasAdminMessage(aliasObject, player);
                }
                return;
            }
        }

        if (aliasObject.permNecessary) {
            if (!(player.hasPermission("t2code.alias.use." + alias.toLowerCase()) || player.hasPermission("t2code.alias.admin"))) {
                send.player(player, SelectMessages.noPermissionForCommand.replace("[cmd]", "/" + alias.toLowerCase())
                        .replace("[perm]", "t2code.alias.use." + alias.toLowerCase()));
                return;
            }
        }
        if (aliasObject.costEnable) {
            if (!(aliasObject.costAllowBypass && player.hasPermission("t2code.alias.buy.bypass"))) {
                if (!Eco.moneyRemove(prefix, player, aliasObject.costPrice)) {
                    send.player(player, SelectMessages.noMoney);
                    return;
                }
                if (SelectConfig.buyMessage) send.player(player, SelectMessages.buy.replace("[price]", aliasObject.costPrice.toString()));
            }
        }
        if (aliasObject.commandEnable) {
            aliasCommand(aliasObject, player);
        }
        if (aliasObject.messageEnable) {
            aliasMessage(aliasObject, player);
        }
    }

    protected static void subAliasPlayer(CommandSender sender, SubAliasObject aliasObject, String alias) {
        if (!aliasObject.subAliasEnable) {
            send.sender(sender, SelectMessages.aliasDisabled);
            return;
        }

        if (sender instanceof Player) {
            Player player = (Player) sender;

            if (aliasObject.adminEnable) {
                if (player.hasPermission(aliasObject.adminPermission)) {
                    if (aliasObject.adminCommandEnable) {
                        subAliasAdminCommand(aliasObject, player);
                    }
                    if (aliasObject.adminMessageEnable) {
                        subAliasAdminMessage(aliasObject, player);
                    }
                    return;
                }
            }

            if (aliasObject.permNecessary) {
                if (!(player.hasPermission("t2code.alias.use.subalias." + alias.toLowerCase()) || player.hasPermission("t2code.alias.admin"))) {
                    send.player(player, SelectMessages.noPermissionForCommand.replace("[cmd]", "/" + alias.toLowerCase())
                            .replace("[perm]", "t2code.alias.subalias.use." + alias.toLowerCase()));
                    return;
                }
            }
            if (aliasObject.costEnable) {
                if (!(aliasObject.costAllowBypass && player.hasPermission("t2code.alias.buy.bypass"))) {
                    if (!Eco.moneyRemove(prefix, player, aliasObject.costPrice)) {
                        send.player(player, SelectMessages.noMoney);
                        return;
                    }
                    if (SelectConfig.buyMessage) send.player(player, SelectMessages.buy.replace("[price]", aliasObject.costPrice.toString()));
                }
            }
            if (aliasObject.commandEnable) {
                subAliasCommand(aliasObject, player);
            }
            if (aliasObject.messageEnable) {
                subAliasMessage(aliasObject, player);
            }
        } else {
            if (aliasObject.consoleEnable) {
                subAliasConsole(aliasObject, sender);
            } else send.sender(sender, SelectMessages.onlyForPlayer);
        }
    }

    protected static void aliasConsole(AliasObject alias, CommandSender sender, String prefix) {
        if (alias.consoleCommandEnable) {
            for (String cmd : alias.consoleCommands) {
                if (alias.consoleBungeeCommand) {
                    if (SelectConfig.Bungee) {
                        BCommandSenderReciver.sendToBungee(sender, cmd, true);
                    } else {
                        send.console(Util.getPrefix() + " §4To use bungee commands, enable the Bungee option in the config.");
                        send.sender(sender, Util.getPrefix() + " §4To use bungee commands, enable the Bungee option in the config.");
                    }
                } else {
                    Cmd.console(cmd);
                }
            }
        }
        if (alias.consoleMessageEnable) {
            for (String msg : alias.consoleMessages) {
                send.console(Replace.replace(prefix, msg));
            }
        }
    }

    private static void subAliasConsole(SubAliasObject alias, CommandSender sender) {
        if (alias.consoleCommandEnable) {
            for (String cmd : alias.consoleCommands) {
                if (alias.consoleBungeeCommand) {
                    if (SelectConfig.Bungee) {
                        BCommandSenderReciver.sendToBungee(sender, cmd, true);
                    } else {
                        send.console(Util.getPrefix() + " §4To use bungee commands, enable the Bungee option in the config.");
                        send.sender(sender, Util.getPrefix() + " §4To use bungee commands, enable the Bungee option in the config.");
                    }
                } else {
                    Cmd.console(cmd);
                }
            }
        }
        if (alias.consoleMessageEnable) {
            for (String msg : alias.consoleMessages) {
                send.console(Replace.replace(prefix, msg));
            }
        }
    }

    private static void aliasAdminCommand(AliasObject alias, Player player) {
        for (String cmd : alias.adminCommands) {
            if (alias.adminBungeeCommand) {
                if (SelectConfig.Bungee) {
                    BCommandSenderReciver.sendToBungee(player, cmd.replace("[player]", player.getName()), alias.adminCommandAsConsole);

                } else {
                    send.console(Util.getPrefix() + " §4To use bungee commands, enable the Bungee option in the config.");
                    send.player(player, Util.getPrefix() + " §4To use bungee commands, enable the Bungee option in the config.");
                }
            } else {
                if (alias.adminCommandAsConsole) {
                    Cmd.console(cmd.replace("[player]", player.getName()));
                } else {
                    Cmd.player(player, cmd.replace("[player]", player.getName()));
                }
            }
        }
    }

    private static void subAliasAdminCommand(SubAliasObject alias, Player player) {
        for (String cmd : alias.adminCommands) {
            if (alias.adminBungeeCommand) {
                if (SelectConfig.Bungee) {
                    BCommandSenderReciver.sendToBungee(player, cmd.replace("[player]", player.getName()), alias.adminCommandAsConsole);

                } else {
                    send.console(Util.getPrefix() + " §4To use bungee commands, enable the Bungee option in the config.");
                    send.player(player, Util.getPrefix() + " §4To use bungee commands, enable the Bungee option in the config.");
                }
            } else {
                if (alias.adminCommandAsConsole) {
                    Cmd.console(cmd.replace("[player]", player.getName()));
                } else {
                    Cmd.player(player, cmd.replace("[player]", player.getName()));
                }
            }
        }
    }

    private static void aliasAdminMessage(AliasObject alias, Player player) {
        for (String msg : alias.adminMessages) {
            String text;
            String hover;
            if (PluginCheck.papi()) {
                text = Replace.replace(prefix, player, replacePlayer(msg, player));
            } else {
                text = Replace.replace(prefix, replacePlayer(msg, player));
            }
            send.player(player, text);
        }
    }

    private static void subAliasAdminMessage(SubAliasObject alias, Player player) {
        for (String msg : alias.adminMessages) {
            String text;
            String hover;
            if (PluginCheck.papi()) {
                text = Replace.replace(prefix, player, replacePlayer(msg, player));
            } else {
                text = Replace.replace(prefix, replacePlayer(msg, player));
            }
            send.player(player, text);
        }
    }

    private static void aliasCommand(AliasObject alias, Player player) {
        for (String cmd : alias.command) {
            if (alias.bungeeCommand) {
                if (SelectConfig.Bungee) {
                    BCommandSenderReciver.sendToBungee(player, cmd.replace("[player]", player.getName()), alias.commandAsConsole);

                } else {
                    send.console(Util.getPrefix() + " §4To use bungee commands, enable the Bungee option in the config.");
                    send.player(player, Util.getPrefix() + " §4To use bungee commands, enable the Bungee option in the config.");
                }
            } else {
                if (alias.commandAsConsole) {
                    Cmd.console(cmd.replace("[player]", player.getName()));
                } else {
                    Cmd.player(player, cmd.replace("[player]", player.getName()));
                }
            }
        }
    }

    private static void subAliasCommand(SubAliasObject alias, Player player) {
        for (String cmd : alias.command) {
            if (alias.bungeeCommand) {
                if (SelectConfig.Bungee) {
                    BCommandSenderReciver.sendToBungee(player, cmd.replace("[player]", player.getName()), alias.commandAsConsole);

                } else {
                    send.console(Util.getPrefix() + " §4To use bungee commands, enable the Bungee option in the config.");
                    send.player(player, Util.getPrefix() + " §4To use bungee commands, enable the Bungee option in the config.");
                }
            } else {
                if (alias.commandAsConsole) {
                    Cmd.console(cmd.replace("[player]", player.getName()));
                } else {
                    Cmd.player(player, cmd.replace("[player]", player.getName()));
                }
            }
        }
    }

    private static void aliasMessage(AliasObject alias, Player player) {
        for (String msg : alias.messages) {
            String text;
            if (PluginCheck.papi()) {
                text = Replace.replace(prefix, player, replacePlayer(msg, player));
            } else {
                text = Replace.replace(prefix, replacePlayer(msg, player));
            }
            send.player(player, text);
        }
    }

    private static void subAliasMessage(SubAliasObject alias, Player player) {
        for (String msg : alias.messages) {
            String text;
            String hover;
            if (PluginCheck.papi()) {
                text = Replace.replace(prefix, player, replacePlayer(msg, player));
            } else {
                text = Replace.replace(prefix, replacePlayer(msg, player));
            }
            send.player(player, text);
        }
    }

    private static String replacePlayer(String s, Player player) {
        return s.replace("[player]", player.getName());
    }
}
